#ifndef	_DGA_DGAGPI_H
#define	_DGA_DGAGPI_H

#pragma ident	"@(#)dgagpi.h	1.15	97/01/27 SMI"

/************************************************************
Copyright 1991,1993 by Sun Microsystems, Inc. Mountain View, CA.

                    All Rights Reserved

Permission  to  use,  copy,  modify,  and  distribute   this
software  and  its documentation for any purpose and without
fee is hereby granted, provided that the above copyright no-
tice  appear  in all copies and that both that copyright no-
tice and this permission notice appear in  supporting  docu-
mentation,  and  that the names of Sun or MIT not be used in
advertising or publicity pertaining to distribution  of  the
software  without specific prior written permission. Sun and
M.I.T. make no representations about the suitability of this
software for any purpose. It is provided "as is" without any
express or implied warranty.

SUN DISCLAIMS ALL WARRANTIES WITH REGARD TO  THIS  SOFTWARE,
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
NESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL SUN BE  LI-
ABLE  FOR  ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,  DATA  OR
PROFITS,  WHETHER  IN  AN  ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION  WITH
THE USE OR PERFORMANCE OF THIS SOFTWARE.

********************************************************/

#include <sys/types.h>
#include "dga_externaldefs.h"
#include "dga_winshared.h"
#include "dgacmapstr.h"
#include "window.h"
#include "gcstruct.h"


/*
 * dgagpi.h Window Grabber
 */
/* Definition DGA availability and cursor information */
#define DGA_NONE          0   /* fb does not suport DGA */
#define DGA_AVAIL_HW_CURS 1             /* DGA supported, cursor always HW */
#define DGA_AVAIL_SW_CURS 2             /* DGA supported, cursor always SW */
#define DGA_AVAIL_HW_SW_CURS 3          /* DGA supported, cursor can switch 
                                         * between hw/sw */

typedef struct _DgaDevFuncs {
    int (*RacheSetup)();        /* rinfop */
    int (*RacheTakedown)();     /* rinfop */
    int (* DbSetup)();          /* pWin, dbinfop, num_buffers, grab_flag */
    int (* WidSetup)();         /* pWin, num_wids */
    int (* FcsSetup)();         /* pWin, num_fcs */
    int (* ZbufSetup)();        /* pWin, zbuf_type */
    int (* StereoSetup)();      /* pWin, st_mode */
    int (* ChokeFb)();          /* pWin, flag */
    int (* DgaAvail)();
    int (* GrabWindow)();       /* pWin, winfop */              
    int (* UngrabWindow)();     /* pWin, winfop */              
    int (* DbValidate)();       /* pGC, winfop */
    int (* CmapSetup)();        /* pCmap, cg_infop */
} DgaDevFuncs;

typedef struct _DgaDevFuncsDraw {
    int         (* DgaAvail)();
    void        (* GrabDrawable)(DrawablePtr);
    void        (* UngrabDrawable)(DrawablePtr);
    int         (* CachedDrawInit)(DrawablePtr);
    int         (* CachedDrawCleanup)(DrawablePtr);
    int         (* DbSetup)(WindowPtr, WXINFO *, int, Bool);
    int         (* WidSetup)(WindowPtr, int, WXINFO *);
    int         (* FcsSetup)(WindowPtr, WXINFO *, int);
    int         (* ZbufSetup)(WindowPtr, int, WXINFO *);
    int         (* StereoSetup)(WindowPtr, int, WXINFO *);
    int         (* ChokeFb)(ScreenPtr, Bool);
    int         (* SyncDrawable)(DrawablePtr, GCPtr);
    int         (* UnsyncDrawable)(DrawablePtr, GCPtr);
    int         (* CmapSetup)(DgaCmapPtr, Grabbedcmap *);
    int         (* BuffersSetup)(WindowPtr, WXINFO *, int, Bool);
    Bool	(* AllowMemoryBuffer )(WindowPtr, Dga_buffer_type);
    Bool	(* BindPixmap ) (PixmapPtr, pointer, int);
} DgaDevFuncsDraw;

extern int      dgaScreenInit(ScreenPtr, void *, int, int);
extern int      dgaMbCrtSetInfo (WindowPtr, int, int, Bool, unsigned long);
extern int      dgaMbSetBufViewability (WindowPtr, short, Bool);
extern void     dgaMbSetDisplayBuf (WindowPtr, short);
extern Bool     dgaMbIsMultibuffer (PixmapPtr, WindowPtr *);
extern int      dgaMbGetBufferInfo (WindowPtr, short *, short *, short *,
                                    short *);
extern void     dgaCacheDescribeDev(DrawablePtr, int, char *);
extern void     dgaCacheStateChange(DrawablePtr, Bool);
extern void     dgaSharedDataInfo(DrawablePtr, pointer *, int *);
extern pointer  dgaDevInfoGet(DrawablePtr);
extern void     dgaDevInfoChange(DrawablePtr);
extern void     dgaAllowMemoryBufferGrabs(ScreenPtr);
extern void     dgaDbIncrSwapbit(WindowPtr);

#endif /* _DGA_DGAGPI_H */
