/*
 *   ----------------------------------------------------------------- 
 *          Copyright (C) 1986,1991  Sun Microsystems, Inc
 *                      All rights reserved. 
 *            Notice of copyright on this source code 
 *            product does not indicate publication. 
 *   
 *                    RESTRICTED RIGHTS LEGEND: 
 *   Use, duplication, or disclosure by the Government is subject 
 *   to restrictions as set forth in subparagraph (c)(1)(ii) of 
 *   the Rights in Technical Data and Computer Software clause at 
 *   DFARS 52.227-7013 and in similar clauses in the FAR and NASA 
 *   FAR Supplement. 
 *   ----------------------------------------------------------------- 
 */


 /*
	dlextn.h - Dynamic loading of extension include file.
	Author:	Murali.
 */
 
#ifndef DLEXTNSTRUCT_H
#define DLEXTNSTRUCT_H

#pragma ident	"@(#)dlextn.h	35.1	94/09/01 LIBPS SMI"


/*** 
	to get at the declaration of the X_dl*() routines 
****/

typedef struct _X_dlextension_entry {
	char *dl_name;				/* name of the extension */
	char *dl_so_name;			/* shared library name */ 
	char *dl_init_func_name;	/* init function */
	int  dl_status;				/* status flags */
	void *dl_handle;			/* handle returned by dlopen() */
} X_dlextension_entry;


/* status flags  */
#define DL_DEMAND_LOAD  0x01       
#define DL_STARTUP_LOAD 0x02          /* extension is loaded during start up */
#define DL_LOADED       0x04
#define DL_ERROR        0x08          /* unable to load extension */
#define DL_CANT_UNLOAD  0x10	      /* don't dlclose extension */


/* Configuration file fields */
#define DL_NUM_FIELDS	     4
#define DL_EXT_NAME          0
#define DL_SO_NAME           1
#define DL_INIT_FUNC_NAME    2
#define DL_AUTOLOAD	     	 3
#define DL_SO_LEN	     	 256
#define DL_LINESIZE          1024
#define DL_OFF_STR	     	 "NO"
#define DL_ON_STR            "YES"

#endif /* DLEXTNSTRUCT_H */
