/*
 * Copyright (c) 1993-1994,2000 by Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef _OS_INTERACTIVE_H
#define _OS_INTERACTIVE_H

#pragma ident "@(#)os_interactive.h	35.4 00/06/14 SMI"

#if 0  
/* only xc/programs/Xserver/Xext/interactive.c needs these and it already
 * includes them
 */
#include <sys/priocntl.h>
#include <sys/iapriocntl.h>
#endif

#include "dix.h"
#include "extensions/interactive.h"

#define UNSET_PRIORITY 		0
#define SET_PRIORITY		1
#define SET_INTERACTIVE 	2

#define SERVER			0x1
#define WMGR			0x2
#define BOTH			0x3

typedef struct _ClientProcessInfo {
	int count;
	ConnectionPidPtr pids;
} ClientProcessRec, * ClientProcessPtr;

extern caddr_t CreateServerOsPrivate();
extern ClientProcessPtr GetConnectionPids(caddr_t);
extern void SetOsPrivate(caddr_t, ConnectionPidPtr, int);
extern void ChangePriority(ClientPtr);
extern void FreeProcessList(caddr_t);
extern void UnsetLastPriority(ClientProcessPtr);
extern int LocalConnection(caddr_t);
extern int PidSetEqual(ClientProcessPtr, ClientProcessPtr);


extern ClientProcessPtr LastPids;
extern int		specialIAset;
extern Bool 		InteractiveOS;

#endif
